/* Start isotope */
$(function(){
  
  var $container = $('#iso-container');

  $container.isotope({
	// options
	   itemSelector: '.element',
		masonry : {
		  columnWidth : 240
		}
  });
  
  
  /* Filtering */
  var $optionSets = $('#options .option-set'),
	  $optionLinks = $optionSets.find('a');

  $optionLinks.click(function(){
	var $this = $(this);
	// don't proceed if already selected
	if ( $this.hasClass('selected') ) {
	  return false;
	}
	var $optionSet = $this.parents('.option-set');
	$optionSet.find('.selected').removeClass('selected');
	$this.addClass('selected');

	// make option object dynamically, i.e. { filter: '.my-filter-class' }
	var options = {},
		key = $optionSet.attr('data-option-key'),
		value = $this.attr('data-option-value');
	// parse 'false' as false boolean
	value = value === 'false' ? false : value;
	options[ key ] = value;
	if ( key === 'layoutMode' && typeof changeLayoutMode === 'function' ) {
	  // changes in layout modes need extra logic
	  changeLayoutMode( $this, options )
	} else {
	  // otherwise, apply new options
	  $container.isotope( options );
	}
	
	return false;
  });

  
});

/* Centered Masonry Columns */
$.Isotope.prototype._getCenteredMasonryColumns = function() {
	this.width = this.element.width();
	
	var parentWidth = this.element.parent().width();
	
				  // i.e. options.masonry && options.masonry.columnWidth
	var colW = this.options.masonry && this.options.masonry.columnWidth ||
				  // or use the size of the first item
				  this.$filteredAtoms.outerWidth(true) ||
				  // if there's no items, use size of container
				  parentWidth;
	
	var cols = Math.floor( parentWidth / colW );
	cols = Math.max( cols, 1 );

	// i.e. this.masonry.cols = ....
	this.masonry.cols = cols;
	// i.e. this.masonry.columnWidth = ...
	this.masonry.columnWidth = colW;
  };
  
  $.Isotope.prototype._masonryReset = function() {
	// layout-specific props
	this.masonry = {};
	// FIXME shouldn't have to call this again
	this._getCenteredMasonryColumns();
	var i = this.masonry.cols;
	this.masonry.colYs = [];
	while (i--) {
	  this.masonry.colYs.push( 0 );
	}
  };

  $.Isotope.prototype._masonryResizeChanged = function() {
	var prevColCount = this.masonry.cols;
	// get updated colCount
	this._getCenteredMasonryColumns();
	return ( this.masonry.cols !== prevColCount );
  };
  
  $.Isotope.prototype._masonryGetContainerSize = function() {
	var unusedCols = 0,
		i = this.masonry.cols;
	// count unused columns
	while ( --i ) {
	  if ( this.masonry.colYs[i] !== 0 ) {
		break;
	  }
	  unusedCols++;
	}
	
	return {
		  height : Math.max.apply( Math, this.masonry.colYs ),
		  // fit container to columns that have been used;
		  width : (this.masonry.cols - unusedCols) * this.masonry.columnWidth
		};
  };


/* Filtering Menu */
$(document).ready(function() { 

	 $('#f-all').hide();
	
	$('#f-one,#f-two,#f-three').click(function() {
		$('#f-all').fadeIn();
	});

	$('#f-all').click(function() {
		$('#f-all').fadeOut();
	});
	 
});